// Fill out your copyright notice in the Description page of Project Settings.


#include "Oleg.h"

#define PrintString(text) if(GEngine)GEngine->AddOnScreenDebugMessage(15, 15, FColor::Green, FString::Printf(TEXT(text)));

const FVector forceViewXY(1, 0, 0);
const FVector forceLocationX(0, -1, 0);
const FVector forceLocationY(0, 0, -4);

const FVector forceViewZ(0, 0, 1);

// Sets default values
AOleg::AOleg()
{
 	// Set this pawn to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
    
    
    Body = CreateDefaultSubobject<UCapsuleComponent>("Body");
    RootComponent = Body;
    
    Camera = CreateDefaultSubobject<UCameraComponent>("Camera");
    Camera->SetupAttachment(Body);
    
    TakedMesh = CreateDefaultSubobject<UStaticMeshComponent>("Taked");
    TakedMesh->SetupAttachment(Body);
    
    Hand = CreateDefaultSubobject<UStaticMeshComponent>("Hand");
    Hand->SetupAttachment(Body);
    
    Shlem = CreateDefaultSubobject<UStaticMeshComponent>("Shlem");
    Shlem->SetupAttachment(Body);
    
}

// Called when the game starts or when spawned
void AOleg::BeginPlay()
{
	Super::BeginPlay();
    
    srand(10);
    
    for(int i = 0; i < TRASH_COUNT; i++){
    
        FRotator rotationGen(rand() % 360, rand() % 360, rand() % 360);
        FVector locationGen(rand() % GenSize - GenSize / 2, rand() % GenSize - GenSize / 2, rand() % GenSize - GenSize / 2);
        
        Trashes[i] = GetWorld()->SpawnActor<ACosmoByak>(locationGen + GetActorLocation(), rotationGen);
        
        int type = rand() % Byaks.Num();
        
        Trashes[i]->Mesh->SetStaticMesh(Byaks[type].DefaultMesh);
        Trashes[i]->Mesh->SetSimulatePhysics(true);
        Trashes[i]->Mesh->SetEnableGravity(false);
        
        locationGen.Set(rand() % 8000 - 4000, rand() % 8000 - 4000, rand() % 8000 - 4000);
        
        Trashes[i]->Mesh->AddForce(locationGen * StartMoveForce);
        
        locationGen.Set(rand() % 60, rand() % 60, rand() % 60);
        
        Trashes[i]->Mesh->AddAngularImpulseInDegrees(locationGen);
        Trashes[i]->type = type;
        
    
    }
    
    for(int i = 0; i < 5; i++){
        
        inventory[i] = -1;
        
    }
	
}

void AOleg::GenObjects(){
    
    if(iGen == TRASH_COUNT)
        iGen = 0;
    
    if((GetActorLocation() - Trashes[iGen]->GetActorLocation()).Size() > GenSize * 2){
        
        GetWorld()->DestroyActor(Trashes[iGen]);
        
        FRotator rotationGen(rand() % 360, rand() % 360, rand() % 360);
        FVector locationGen(rand() % GenSize - GenSize / 2, rand() % GenSize - GenSize / 2, rand() % GenSize - GenSize / 2);
        Trashes[iGen] = GetWorld()->SpawnActor<ACosmoByak>(locationGen + GetActorLocation() + Body->GetPhysicsLinearVelocity(), rotationGen);
        
        int type = rand() % Byaks.Num();
        
        Trashes[iGen]->Mesh->SetStaticMesh(Byaks[type].DefaultMesh);
        Trashes[iGen]->Mesh->SetSimulatePhysics(true);
        Trashes[iGen]->Mesh->SetEnableGravity(false);
        
        locationGen.Set(rand() % 4000 - 2000, rand() % 4000 - 2000, rand() % 4000 - 2000);
        FVector outSphere = locationGen;
        outSphere.Normalize(0.1);
        
        Trashes[iGen]->Mesh->AddForce(locationGen * StartMoveForce + outSphere * GenSize);
        
        locationGen.Set(rand() % 60, rand() % 60, rand() % 60);
        
        Trashes[iGen]->Mesh->AddAngularImpulseInDegrees(locationGen);
        Trashes[iGen]->type = type;
        
        PrintString("Gam");
        
        
    }
    
    iGen++;
    
}

// Called every frame
void AOleg::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
    
    float FB = GetInputAxisValue("FB");
    float RL = GetInputAxisValue("RL");
    float VX = GetInputAxisValue("VX");
    float VY = GetInputAxisValue("VY");
    float UD = GetInputAxisValue("UD");
    
    moveVector = GetActorForwardVector() * (FB * MoveBoost);
    moveVector += GetActorRightVector() * (RL * MoveBoost);
    
    Body->AddForce(moveVector);
    
    //GenObjects();
    
    //rotationVector.Set(0, -, GetInputAxisValue("VX"));
    
    //AddActorLocalRotation(rotation);
    Body->AddForceAtLocationLocal(forceViewXY, forceLocationX * VX * ViewBoost);
    Body->AddForceAtLocationLocal(forceViewXY, forceLocationY * VY * ViewBoost);
    Body->AddForceAtLocationLocal(forceViewZ,  forceLocationX * UD * ViewBoost);
    
    
    FHitResult out;
    
    FCollisionQueryParams a; 
    
    bool isFind = GetWorld()->LineTraceSingleByChannel(out, GetActorLocation() + GetActorForwardVector() * 50, GetActorLocation() + GetActorForwardVector() * 1000, ECC_Visibility, a);
    
    if(takedByak != nullptr && takedByak->type == -2){
        if(SM->GetMaterial(0) == GLMaterial){
            
            
            SM->SetVisibility(false);
            
        }
    }
        
    takedByak = Cast<ACosmoByak>(out.GetActor());
    if(takedByak != nullptr){
        if(takedByak->type == -2){
            
            SM = Cast<UStaticMeshComponent>(out.GetComponent());
            
            if(SM != nullptr && SM->GetMaterial(0) == GLMaterial){
                
                SM->SetVisibility(true);
                
            }
            
        }else
        
        if(takedByak->type == -3){
            
            SM = Cast<UStaticMeshComponent>(out.GetComponent());
            
            if(SM != nullptr && SM->GetMaterial(0) == GLMaterial){
                
                SM->SetVisibility(true);
                
            }
            
        }else
        
        if(takedByak->type == -4){
            
            SM = Cast<UStaticMeshComponent>(out.GetComponent());
            
            if(SM != nullptr && SM->GetMaterial(0) == GLMaterial){
                
                SM->SetVisibility(true);
                
            }
            
        }
    }
        
    

}

void AOleg::take(){
    
    FHitResult out;
    
    FCollisionQueryParams a; 
    
    bool isFind = GetWorld()->LineTraceSingleByChannel(out, GetActorLocation() + GetActorForwardVector() * 50, GetActorLocation() + GetActorForwardVector() * 1000, ECC_Visibility, a);
    if(isFind){
        
        takedByak = Cast<ACosmoByak>(out.GetActor());
        if(takedByak != nullptr){
            
            if(takedByak->type < -1 && inventory[invCursor] > 0){
                
                SM = Cast<UStaticMeshComponent>(out.GetComponent());
                
                if(SM != nullptr){
                    
                    SM->SetMaterial(0, Material1);
                    SM->SetMaterial(1, Material2);
                    SM->SetMaterial(2, Material3);
                    SM->SetCollisionProfileName("BlockAll");
                    done++;
                    inventory[invCursor] = -1;
                    TakedMesh->SetStaticMesh(nullptr);
                    
                }
                
            }
                
            
            if(inventory[invCursor] == -1 && takedByak->type >= 0){
                
                inventory[invCursor] = takedByak->type;
                TakedMesh->SetStaticMesh(Byaks[takedByak->type].DefaultMesh);
                GetWorld()->DestroyActor(takedByak);

            } 
            
            
        }
        
    }
    
    
}

void AOleg::IPlus(){
    
    invCursor ++;
        
    if(invCursor >= 5)
        invCursor = 0;
        
        
    if(inventory[invCursor] != -1)
            
        TakedMesh->SetStaticMesh(Byaks[inventory[invCursor]].DefaultMesh);
            
    else
            
        TakedMesh->SetStaticMesh(nullptr);
    
}

void AOleg::IMinus(){
    
    invCursor --;
    
    if(invCursor < 0)
        invCursor = 4;
        
    if(inventory[invCursor] != -1)
            
        TakedMesh->SetStaticMesh(Byaks[inventory[invCursor]].DefaultMesh);
            
    else
            
        TakedMesh->SetStaticMesh(nullptr);
    
}

// Called to bind functionality to input
void AOleg::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
	Super::SetupPlayerInputComponent(PlayerInputComponent);
    
    PlayerInputComponent->BindAxis(TEXT("FB"));
    PlayerInputComponent->BindAxis(TEXT("RL"));
    PlayerInputComponent->BindAxis(TEXT("UD"));
    PlayerInputComponent->BindAxis(TEXT("VX"));
    PlayerInputComponent->BindAxis(TEXT("VY"));
    PlayerInputComponent->BindAction("ST", IE_Pressed, this, &AOleg::take);
    
    PlayerInputComponent->BindAction("IR", IE_Pressed, this, &AOleg::IPlus);
    PlayerInputComponent->BindAction("IL", IE_Pressed, this, &AOleg::IMinus);
    
    //PlayerInputComponent->BindAction("JP", IE_Pressed,  this, &ABaseCharacter::preJump);
    //PlayerInputComponent->BindAction("SU", IE_Pressed,  this, &ABaseCharacter::SwitchSU);
    //PlayerInputComponent->BindAction("SU", IE_Released, this, &ABaseCharacter::SwitchSU);
    
    //PlayerInputComponent->BindAction("WR", IE_Pressed, this, &ABaseCharacter::reload);
    
}

