// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Pawn.h"
#include "Components/CapsuleComponent.h"
#include "Components/StaticMeshComponent.h"
#include "Camera/CameraComponent.h"
#include "Engine/World.h"
#include "CosmoByak.h"
#include "cstdlib"
#include "Oleg.generated.h"

#define TRASH_COUNT 50

USTRUCT(BlueprintType)
struct FSpaceSets
{
	GENERATED_BODY()

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Trash")
    UStaticMesh* DefaultMesh;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Trash")
    bool useable = false;
    
};


UCLASS()
class SPACEPIPE_API AOleg : public APawn
{
	GENERATED_BODY()

public:
	// Sets default values for this pawn's properties
    
    UPROPERTY(VisibleAnywhere, BlueprintReadOnly)
    UCapsuleComponent* Body;
    
    UPROPERTY(VisibleAnywhere, BlueprintReadOnly)
    UStaticMeshComponent* TakedMesh;
    
    UPROPERTY(VisibleAnywhere, BlueprintReadOnly)
    UStaticMeshComponent* Shlem;
    
    UPROPERTY(VisibleAnywhere, BlueprintReadOnly)
    UStaticMeshComponent* Hand;
    
    UPROPERTY(VisibleAnywhere, BlueprintReadOnly)
    UCameraComponent* Camera;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Objects")
    TArray <FSpaceSets> Byaks;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Objects")
    UMaterial* GLMaterial;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Objects")
    UMaterial* Material1;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Objects")
    UMaterial* Material2;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Objects")
    UMaterial* Material3;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Objects")
    int GenSize = 10000;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Objects")
    float StartMoveForce = 10000;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Objects")
    float StartRotateForce = 10000;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Movement")
    float MoveBoost = 1;
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Movement")
    float ViewBoost = 1;
    
    
	AOleg();
    
    void take();
    void IPlus();
    void IMinus();
    
    void GenObjects();
    
    
    ACosmoByak* Trashes[TRASH_COUNT];
    ACosmoByak* takedByak;
    UStaticMeshComponent* SM;
    
    int inventory[5];
    
    int invCursor = 0;
    int iGen = 0;
    int done = 0;
    
    float rotationX = 0;
    float rotationY = 0;
    
    FVector rotationVector;
    FVector moveVector;
    
    
    

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	// Called to bind functionality to input
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;

	
	
};
